unit Login;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, DB, Messages;

type
  TLoginForm = class(TForm)
    AliasCombo: TComboBox;
    PasswordLabel: TLabel;
    PasswordEdit: TEdit;
    OKButton: TBitBtn;
    CancelButton: TBitBtn;
    AliasLabel: TLabel;
    UserLabel: TLabel;
    UserEdit: TEdit;
    bvlFrame: TBevel;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    function GetAlias: String;
    procedure SetAlias(const cAlias: String);
    function GetUser: String;
    procedure SetUser(const cUser: String);
    function GetPassword: String;
    procedure SetPassword(const cPassword: String);
  public
    { Public declarations }
    property Alias : String read GetAlias write SetAlias;
    property User : String read GetUser write SetUser;
    property Password : String read GetPassword write SetPassword;
  end;

var
  LoginForm: TLoginForm;

implementation

{$R *.DFM}

procedure TLoginForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
  var Control  : TObject;
begin
   if Key=VK_RETURN then
      begin
         Control := (Sender as TForm).ActiveControl;
         if Control=AliasCombo then
            if UserEdit.Enabled then
               UserEdit.SetFocus
            else if PasswordEdit.Enabled then
               PasswordEdit.SetFocus
            else
               OKButton.Click
         else if Control=UserEdit then
            if PasswordEdit.Enabled then
               PasswordEdit.SetFocus
            else
               OKButton.Click
         else
            OKButton.Click;
      end;
end;

function TLoginForm.GetAlias : String;
begin
   GetAlias := AliasCombo.Text;
end;

procedure TLoginForm.SetAlias(const cAlias: String);
begin
   if Length(cAlias)>0 then
      begin
         AliasCombo.Text := cAlias;
         AliasCombo.Enabled := False;
      end;
end;

function TLoginForm.GetUser : String;
begin
   GetUser := UserEdit.Text;
end;

procedure TLoginForm.SetUser(const cUser: String);
begin
   if Length(cUser)>0 then
      begin
         UserEdit.Text := cUser;
         UserEdit.Enabled := False;
      end;
end;

function TLoginForm.GetPassword : String;
begin
   GetPassword := PasswordEdit.Text;
end;

procedure TLoginForm.SetPassword(const cPassword: String);
begin
   if Length(cPassword)>0 then
      begin
         PasswordEdit.Text := cPassword;
         PasswordEdit.Enabled := False;
      end;
end;

procedure TLoginForm.FormCreate(Sender: TObject);
begin
   Session.GetAliasNames(AliasCombo.Items);
end;

procedure TLoginForm.FormShow(Sender: TObject);
begin
   if AliasCombo.Enabled then
      AliasCombo.SetFocus
   else if UserEdit.Enabled then
      UserEdit.SetFocus
   else if PasswordEdit.Enabled then
      PasswordEdit.SetFocus
   else
      Close;
end;

end.

